/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.2 by edhill, Mon Sep 1 16:50:27 2003 UTC revision 1.134 by jmc, Sun Jan 17 21:52:01 2010 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  #  $Header$  #  $Header$
4    #  $Name$
5  #  #
6    
7  usage()  usage()
# Line 10  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-optfile=|-of=)STRING   list of genmake2 \"optfiles\""      echo "  (-mth)                   run multi-threaded (using eedata.mth)"
15      echo "  (-a|-addr)STRING         list of email recipients"      echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-t|-tdir)STRING         list of \"test\" dirs"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17        echo "                             (DEF=\"-ieee\")"
18        echo "  (-gsl)                   compile with \"-gsl\" flag"
19        echo "  (-of=|-optfile=)STRING   list of optfiles to use"
20        echo "  (-a|-addr) STRING        list of email recipients"
21        echo "                             (DEF=\"\" no email is sent)"
22        echo "  (-mpd|-mpackdir) DIR     location of the mpack utility"
23        echo "                             (DEF=\"../tools/mpack-1.6\")"
24        echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
25        echo "                             (recognized groups: basic, tutorials)"
26        echo "                             (DEF=\"\" which test all)"
27        echo "  (-skd|-skipdir) STRING   list of exp. dirs to skip"
28        echo "                             (DEF=\"\" which test all)"
29        echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"
30        echo "                             Bourne-compatible \"sh\" shell"
31        echo "                             (DEF=\"\" for \"bash\")"
32        echo "  (-adm|-ad)               perform an adjoint run"
33        echo "  (-oad)                   perform an OpenAD adjoint run"
34        echo "  (-command) STRING        command to run"
35        echo "                             (DEF=\"make output.txt\")"
36        echo "  (-m|-make) STRING        command to use for \"make\""
37        echo "                             (DEF=\"make\")"
38        echo "  (-odir) STRING           used to build output directory name"
39        echo "                             (DEF=\"hostname\")"
40        echo "  (-ptr|-ptracers) STRING  specify which ptracers to test"
41        echo "                             (DEF=\"1 2 3 4 5\")"
42        echo "  (-match) NUMBER          Matching Criteria (number of digits)"
43        echo "                             (DEF=\"12\")"
44        echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
45        echo "  (-clean)                 *ONLY* run \"make CLEAN\""
46        echo "  (-norun|-nr)             skip the \"runmodel\" stage (stop after make)"
47        echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
48        echo "  (-nogenmake|-ng)         skip the genmake stage"
49        echo "  (-noclean|-nc)           skip the \"make clean\" stage"
50        echo "  (-nodepend|-nd)          skip the \"make depend\" stage"
51        echo "  (-deldir|-dd)            on success, delete the output directory"
52        echo "  (-ts)                    provide timing information per timestep"
53        echo "  (-papis)                 provide MFlop/s per timestep using PAPI"
54        echo "  (-pcls)                  provide MFlop/s per timestep using PCL"
55        echo
56        echo "and where STRING can be a whitespace-delimited list"
57        echo "such as:"
58        echo
59        echo "  -t 'exp0 exp2 exp3' "
60        echo "  -addr='abc@123.com testing@home.org'"
61        echo
62        echo "provided that the expression is properly quoted within the current"
63        echo "shell (note the use of single quotes to protect white space)."
64      echo      echo
65      exit 1      exit 1
66  }  }
# Line 20  usage() Line 68  usage()
68  #  build the mpack utility  #  build the mpack utility
69  build_mpack()  build_mpack()
70  {  {
71      echo -n "building the mpack utility...  "      printf "building the mpack utility...  "
72      if test ! -x "$MPACKDIR/mpack" ; then      MPACK="$MPACKDIR/mpack"
73        if test ! -x $MPACK ; then
74          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
75                echo
76              echo "Error: can't find \"$MPACKDIR\""              echo "Error: can't find \"$MPACKDIR\""
77              echo "  are you sure this program is being run in the correct "              echo "  are you sure this program is being run in the correct "
78              echo "  (that is, \"MITGCM_ROOT\verification\") directory?"              echo "  (that is, \"MITGCM_ROOT\verification\") directory?"
79              exit 1              echo
80                HAVE_MPACK=f
81          fi          fi
82          echo -n "building mpack...  "          if test "x$CC" = x ; then
83          ( cd $MPACKDIR && ./configure && make ) > build_mpack.out 2>&1              export CC=cc
84            fi
85            printf "building mpack (using CC=$CC)...  "
86            ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
87          RETVAL=$?          RETVAL=$?
88          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
89              echo              echo
90              echo "Error building the mpack tools at: $MPACK_DIR"              echo "Error building the mpack tools at: $MPACK_DIR"
91              exit 1              echo
92                HAVE_MPACK=f
93            else
94                rm -f tr_build_mpack.out
95                HAVE_MPACK=t
96                echo "done"
97          fi          fi
98        else
99            HAVE_MPACK=t
100            echo "already exist"
101      fi      fi
     echo "OK"  
 }  
   
 compare_lines()  
 {  
     # use codelet to compare lines  
     if [ $verbose -gt 1 ]; then  
         cat tmp3.txt 1>&2  
     fi  
     return `./a.out < tmp3.txt`  
102  }  }
103    
104  testoutput_for_prop()  testoutput_var()
105  {  {
106      # testoutput_for_prop dir s1 label subdir      # testoutput_var dir s1 label subdir reference_output
107      #      #
108      #  compares files in $dir/$subdir/output.txt and $dir/results/output.txt      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
109      #  using search strings s1 and text label      #     with same output from reference file $dir/results/$reference_output
110        #  using search strings s1 and text label
111    
112      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
113          echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2          echo testoutput_var: grep "$2" $1/$4/$OUTPUTFILE 1>&2
114      fi      fi
115      if [ -r $1/$4/output.txt ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
116          grep "$2" $1/$4/output.txt | sed 's/.*=//' | nl > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt
117          lncnt=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
118          if [ $lncnt -lt 3 ]; then          if [ $lncntA -lt 2 ]; then
119              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
120                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
121              fi              fi
122              return 99              return 99
123          fi          fi
124      else      else
125          echo testoutput_for_prop: output.txt from model run was not readable 1>&2          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2
126          return 99          return 99
127      fi      fi
128      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
129          echo testoutput_for_prop: grep "$2" $1/results/output.txt 1>&2          echo testoutput_var: grep "$2" $1/results/$5 1>&2
130      fi      fi
131      grep "$2" $1/results/output.txt | sed 's/.*=//' | nl > tmp2.txt      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt
132      lncnt=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
133      if [ $lncnt -lt 3 ]; then      if [ $lncntB -lt 2 ]; then
134          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
135              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
136          fi          fi
137          return 99          return 99
138      fi      fi
139        if [ $lncntA -ne $lncntB ]; then
140            if [ $verbose -gt 0 ]; then
141                echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2
142            fi
143            return 99
144        fi
145        has_nan=`cat tmp1.txt | grep -i nan | wc -l`
146        if [ $has_nan -gt 0  ] ; then
147            echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2
148            return 99
149        fi
150        has_inf=`cat tmp1.txt | grep -i inf | wc -l`
151        if [ $has_inf -gt 0  ] ; then
152            echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2
153            return 99
154        fi
155      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
156          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2
157      fi      fi
158      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt
159      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
160          echo testoutput_for_prop: compare_lines 1>&2          echo testoutput_var: compare_lines 1>&2
161        fi
162        if [ $verbose -gt 1 ]; then
163            cat tmp3.txt 1>&2
164      fi      fi
165      compare_lines      echo "-1" >> tmp3.txt
166      digits_of_similarity=$?      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
167        cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
168        digits_of_similarity=`./tr_cmpnum < tmp4.txt`
169      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
170          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
171              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2              echo testoutput_var: No comparison was available for \"$3\" 1>&2
172          fi          fi
173          digits_of_similarity=99          digits_of_similarity=99
174      else      else
175          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
176              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
177          fi          fi
178      fi      fi
179      rm tmp1.txt tmp2.txt tmp3.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
180            
181      return $digits_of_similarity      return $digits_of_similarity
182  }  }
183    
184  dashnum()  testoutput_run()
185  {  {
186      # dashnum n1 n2 n3 ...      # testoutput_run directory subdir reference_output
187      #      #
188      #  print numbers using %3i format or "--" if number = 99      #  test output from 1 run in "directory"
189    # --> same processing for adjoint & forward test
190            # default list of output variables to be checked:
191            #  1rst : main variable used to decide if it pass or FAIL
192            #  others : number of matching digits to be printed in summary.txt
193            listChk=$DEF_CHECK_LIST
194            #  load experiment-specific list from file "tr_checklist" (if it exist)
195            if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
196            sVar=`echo $listChk | awk '{print $1}'`
197            # remove 1rst var and expand the list: + => min max mean s.d
198            listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
199                                   | sed 's/+//g' | sed "s/^$sVar//"`
200            if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
201            # check for ptracer output in reference_output file :
202            outpref=$1/results/$3
203            ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
204            ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
205            for ii in $PTRACERS_NUM ; do
206                ptrfound=0
207                for jj in $ptr_mon ; do
208                    name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
209                    tst=`grep $name $outpref | wc -l | awk '{print $1}'`
210                    if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
211                done
212                if test $ptrfound = '1' ; then
213                    eval "HAVE_PTR0"$ii"=t"
214                else
215                    eval "HAVE_PTR0"$ii"=f"
216                  if test "x$ADM" = x -a "x$OADM" = x; then
217                  # remove this ptr from the list of output variable to check
218                  # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
219                    listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
220                  fi
221                fi
222            #   eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
223            done
224            tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
225            if test $tst != 1 ; then
226              if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
227                     else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
228              echo "==> WARNING: in checked list:" $listVar 1>&2
229            #- put it back once:
230              listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
231            fi
232            if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
233            echo "listVar='$listVar'" > $CDIR"/summary.txt"
234            allargs=""
235            for xx in $listVar
236            do
237              case $xx in
238               'PS')  if [ $debug -gt 0 ]
239                      then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
240                      testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?
241                      if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
242              'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;
243              'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;
244               'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;
245               'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;
246               'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;
247               'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;
248               'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;
249               'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;
250               'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;
251               'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;
252               'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;
253               'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;
254               'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;
255               'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;
256               'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;
257               'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;
258               'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;
259               'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;
260            'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
261               testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;
262            'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
263               testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $3; yy=$? ;;
264            'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
265               testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
266            'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
267               testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
268             'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
269             'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
270             'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $3; yy=$? ;;
271             'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
272             'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
273             'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
274             'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
275             'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;
276             'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;
277             'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Heff max"   $2 $3; yy=$? ;;
278             'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Heff mean"  $2 $3; yy=$? ;;
279             'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Heff StDv"  $2 $3; yy=$? ;;
280            'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;
281            'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;
282            'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;
283            'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;
284            'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;
285            'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;
286                  *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
287              esac
288              if test $xx = $sVar
289              then allargs="$allargs > $yy <"
290              else allargs="$allargs $yy"
291              fi
292            done
293    
294            nbVar=`echo $listVar | awk '{print NF}'`
295            if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
296            #-- fill line (up to standard length) with dot:
297              adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
298              echo $allargs $adNul
299            else
300              echo $allargs
301            fi
302    # <-- same processing for adjoint & forward test
303    }
304    
305      for num in $@ ; do  genmakemodel()
306          if [ $num = 99 ]; then  {
307              printf ' --'      # genmakemodel directory
308        if test "x$NOGENMAKE" = xt ; then
309            echo "genmake skipped!"
310        else
311            if test "x$BASH" = x ; then
312                GENMAKE2="../../../tools/genmake2"
313          else          else
314              printf '%3i' $num              GENMAKE2="$BASH ../../../tools/genmake2 -bash $BASH"
315          fi          fi
316      done          (
317                cd $1;
318                command="$GENMAKE2  -ds -m $MAKE"
319                if test "x$ADM" = xt ; then
320                    command="$command --mods=../code_ad"
321                elif test "x$OADM" = xt ; then
322                    command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"
323                else
324                    command="$command -mods=../code"
325                fi
326                if test "x$OPTFILE" != xNONE ; then
327                    command="$command -optfile=$OPTFILE"
328                fi
329                if test "x$IEEE" != x ; then
330                    command="$command -ieee"
331                fi
332                if test "x$GSL" = xt ; then
333                    command="$command -gsl"
334                fi
335                if test "x$MPI" = xt ; then
336                    command="$command -mpi"
337                fi
338                if test "x$MULTI_THREAD" = xt ; then
339                #- run multi-threaded using OpenMP:
340                    command="$command -omp"
341                fi
342                if test "x$TS" = xt ; then
343                    command="$command -ts"
344                fi
345                if test "x$PAPIS" = xt ; then
346                    command="$command -papis"
347                else
348                if test "x$PCLS" = xt ; then
349                    command="$command -pcls"
350                fi
351                fi
352                printf 'genmake ... ' 1>&2
353                # $command > make.log 2>&1
354                eval $command > make.log 2>&1
355                RETVAL=$?
356                #  Reduce the size of the testing emails!
357                head -100 Makefile > $CDIR/Makefile_head
358                if test "x$RETVAL" != x0 ; then
359                    tail make.log
360                    echo "genmakemodel: genmake failed" 1>&2
361                    cp genmake_* make.log $CDIR
362                    return 1
363                else
364                    echo "successful" 1>&2
365                fi
366            )
367        fi
368  }  }
369    
370  testoutput()  makeclean()
371  {  {
372      # testoutput diretory subdir      # makeclean directory
373      #      if test "x$NOCLEAN" = xt ; then
374      #  test output in "directory"          echo "make Clean skipped!"
375        else
376      if [ $debug -gt 0 ]; then          (
377          echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2              cd $1;
378      fi              #if test -e $OUTPUTFILE ; then rm -f $OUTPUTFILE ; fi
379      testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2; cg2dres=$?              if test -r Makefile ; then
380      if [ $debug -gt 0 ]; then                  printf 'clean build-dir: make Clean ... ' 2>&1
381          echo testoutput: cg2dres=$cg2dres 1>&2                  $MAKE Clean >> make.log 2>&1
382                    RETVAL=$?
383                    if test "x$RETVAL" != x0 ; then
384                        tail make.log
385                        echo "makeclean: \"make Clean\" failed" 1>&2
386                        cp make.log $CDIR"/make.log"
387                        return 1
388                    fi
389                    echo successful 1>&2
390                else
391                    echo ''
392                fi
393                exit 0
394            )
395      fi      fi
       
     testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2; tmin=$?  
     testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2; tmax=$?  
     testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2; tmean=$?  
     testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2; tsd=$?  
     testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2; smin=$?  
     testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2; smax=$?  
     testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2; smean=$?  
     testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2; ssd=$?  
     testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2; umin=$?  
     testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2; umax=$?  
     testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2; umean=$?  
     testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2; usd=$?  
     testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2; vmin=$?  
     testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2; vmax=$?  
     testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2; vmean=$?  
     testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2; vsd=$?  
       
     dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \  
         $umin $umax $umean $usd $vmin $vmax $vmean $vsd  
396  }  }
397    
398  genmakemodel()  run_clean()
399  {  {
400      # genmakemodel directory      # run_clean directory
401      GENMAKE2="../../../tools/genmake2"      if test "x$NOCLEAN" = xt ; then
402      (          echo "run_clean skipped!"
403          cd $1;      else
404          printf 'genmake ... ' 1>&2          (
405          # ../../../tools/genmake -ieee -mods=../code > make.log 2>&1              cd $1;
406          $GENMAKE2  -ds --mods=../code "--optfile="$OPTFILE > make.log 2>&1              printf 'clean run-dir ... ' 2>&1
407          RETVAL=$?              # part of what is done after "make clean" when doing "make CLEAN"
408          for i in gm_state gm_optfile gm_local Makefile ; do              find . -name "*.meta" -exec rm {} \;
409              if test -r $i ; then              find . -name "*.data" -exec rm {} \;
410                  cp $i $CDIR              find . -name "fort.*" -exec rm {} \;
411              fi              find . -type l -exec rm {} \;
412          done              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
413          if test "x$RETVAL" != x0 ; then              rm -rf mnc_test_*
414              tail make.log              rm -f *_MIT_CE_000.opt0000 costfunction*0000
415              echo "genmakemodel: genmake failed" 1>&2              echo successful 1>&2
416              cp make.log $CDIR              exit 0
417              return 1          )
418          else      fi
             echo "succesful" 1>&2  
         fi  
     )  
419  }  }
420    
421  makeclean()  makedependmodel()
422  {  {
423      # makeclean directory      # makedependmodel directory
424      (      if test "x$NODEPEND" = xt ; then
425          cd $1;          echo "make depend skipped!"
426          rm -f output.txt      else
427          printf 'make CLEAN ... ' 2>&1          (
428          if test -r Makefile ; then              cd $1;
429              make CLEAN >> make.log 2>&1              printf 'make depend ... ' 1>&2
430                $MAKE depend >> make.log 2>&1
431              RETVAL=$?              RETVAL=$?
432              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
433                  tail make.log                  tail make.log
434                  echo "makeclean: \"make CLEAN\" failed" 1>&2                  echo "makedependmodel: make depend failed" 1>&2
435                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
436                  return 1                  return 1
437                else
438                    echo successful 1>&2
439              fi              fi
440          fi          )
441          echo succesful 1>&2      fi
         exit 0  
     )  
 }  
   
 makedependmodel()  
 {  
     # makedependmodel directory  
     (  
         cd $1;  
         printf 'make depend ... ' 1>&2  
         make depend >> make.log 2>&1  
         RETVAL=$?  
         if test "x$RETVAL" != x0 ; then  
             tail make.log  
             echo "makedependmodel: make depend failed" 1>&2  
             cp make.log $CDIR"/make.log"  
             return 1  
         else  
             echo succesful 1>&2  
         fi  
     )  
442  }  }
443    
444  makemodel()  makemodel()
# Line 231  makemodel() Line 448  makemodel()
448          cd $1;          cd $1;
449          if test -r Makefile ; then          if test -r Makefile ; then
450              printf 'make ... ' 1>&2              printf 'make ... ' 1>&2
451              make >> make.log 2>&1              if test "x$ADM" = xt ; then
452                    $MAKE adall >> make.log 2>&1
453                elif test "x$OADM" = xt ; then
454                    $MAKE adAll >> make.log 2>&1
455                else
456                    if test "x$JOBS" = x ; then
457                        $MAKE >> make.log 2>&1
458                    else
459                        $MAKE -j $JOBS >> make.log 2>&1
460                    fi
461                fi
462              RETVAL=$?              RETVAL=$?
463              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
464                  tail make.log                  tail make.log
465                  echo failed 1>&2                  echo failed 1>&2
466                  cp make.log $CDIR"/make.log"                  cp make.log $CDIR"/make.log"
467                    rm -f $EXECUTABLE
468                  return 1                  return 1
469              else              else
470                  echo succesful 1>&2                  echo successful 1>&2
471              fi              fi
472          fi          fi
473      )      )
474  }  }
475    
476    symlink_mpifiles()
477    {
478        # Put special links so that MPI specific files are used
479        # This MUST be invoked between makeclean and makelinks because
480        # the Makefile will link to non-mpi files by default
481    
482        dir=$1
483        code_dir=$2
484        BUILD_DIR=$dir/$3
485        CODE_DIR=$dir/$code_dir
486        
487        # These are files that should replace their counter-part when using -mpi
488        MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
489    
490        #  Is this an MPI run?
491        if test "x$MPI" = xt ; then
492            # YES: We symbolically link these files to the build
493            # dir so long as there is no real file in place
494            for ii in $MPI_FILES ; do
495                i=`echo $ii | sed 's:^\./::'`
496                name=`echo $i | sed 's:_mpi::' `
497                cmp $CODE_DIR/$i $BUILD_DIR/$name > /dev/null 2>&1
498                RETVAL=$?
499                if test "x$RETVAL" != x0 ; then
500                    if ! test -f $BUILD_DIR/$i ; then
501                        #echo Linking $name to $i
502                        (cd $BUILD_DIR; ln -sf ../$code_dir/$i $name)
503                    fi
504                fi
505            done
506        else
507            # NO: We undo any _mpi symbolically linked files
508            for ii in $MPI_FILES ; do
509                i=`echo $ii | sed 's:^\./::'`
510                name=`echo $i | sed 's:_mpi::' `
511                if test -L $BUILD_DIR/$name ; then
512                    cmp $BUILD_DIR/$name "../$code_dir/$name"_mpi > /dev/null 2>&1
513                    RETVAL=$?
514                    if test "x$RETVAL" = x0 ; then
515                        #echo Un-linking $name from $linktarg
516                        rm -f $BUILD_DIR/$name
517                    fi
518                fi
519            done
520        fi
521        
522    }
523    
524  linkdata()  linkdata()
525  {  {
526      # linkdata flag      # linkdata run_dir input_dir_1 input_dir_2 ...
527      #      #
528      # symbolically link data files to run directory      # symbolically link data files to run directory
529      if [ $1 -ne 0 ]; then      if test -d $1 ; then
530          ( cd $2 ;  ln -sf ../input/* . )          (
531                cd $1 ; shift
532                inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`
533                for xx in $inpMPI ; do
534                  if test -r "../"$1"/"$xx ; then
535                    # found 1 _mpi sfx file in 1rst input dir and it is readable
536                    yy=`echo $xx | sed 's:\.mpi$::'`
537                    if test "x$MPI" = "xt" ; then
538                    # mpi test: remove symbolic link & link _mpi sfx file
539                        if test -h $yy ; then rm -f $yy ; fi
540                        if test ! -r $yy ; then
541                            ln -sf "../"$1"/"$xx $yy ;
542                            printf "$xx " 1>&2
543                        fi
544                    else
545                    # not mpi test: remove symbolic link
546                        if test -h $yy ; then rm -f $yy ; fi
547                    fi
548                  fi
549                done
550                if test -r "../"$1"/eedata.mth" ; then
551                # found eedata.mth in 1rst input dir and it is readable
552                    if test "x$MULTI_THREAD" = "xt" ; then
553                    # multi-threaded test: remove symbolic link & link eedata.mth
554                        if test -h eedata ; then rm -f eedata ; fi
555                        if test ! -r eedata ; then
556                            ln -sf "../"$1"/eedata.mth" eedata ;
557                            printf 'eedata.mth ' 1>&2
558                        fi
559                    else
560                    # not multi-threaded test: remove eedata symbolic link
561                        if test -h eedata ; then rm -f eedata ; fi
562                    fi
563                fi
564                prevDir='NONE'
565                for ldir in $* ; do
566                    if test -d "../"$ldir -a $ldir != $prevDir ; then
567                        printf 'ldir='${ldir} 1>&2
568                        files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
569                        for i in $files ; do
570                            if test ! -d "../"$ldir/$i ; then
571                                if test ! -r $i  ; then
572                                    printf ' '$i 1>&2
573                                    ln -sf "../"$ldir"/"$i $i
574                                fi
575                            fi
576                        done
577                        if test -x "../"$ldir"/"prepare_run ; then
578                            "../"$ldir"/"prepare_run
579                        fi
580                        printf ' ; ' 1>&2
581                    fi
582                    prevDir=$ldir
583                done
584            )
585      fi      fi
586  }  }
587    
588  runmodel()  runmodel()
589  {  {
590      # runmodel directory exe      # runmodel directory
591      #      #
592      #  runs the model "exe" in "directory" (exe is relative to directory)      #  runs "$COMMAND in "directory"
593        #  (where "$COMMAND" is relative to "directory")
594      (      (
595          cd $1          cd $1
596          if [ -x $2 ]; then          printf 'runmodel in %s ...' $1 1>&2
597              if [ $quick -eq 0 ]; then          # make output.txt
598                  rm -f output.txt          echo
599              fi          if test -L $EXECUTABLE ; then
600              printf 'runmodel: ' 1>&2            if test -x "../"$builddir"/"$EXECUTABLE ; then
601              make output.txt              diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
602              RETVAL=$?              outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; fi
603              if test "x$RETVAL" = x0 ; then            else rm -f $EXECUTABLE
604                  cp output.txt $CDIR"/output.txt"            fi
605                  return 0          fi
606            if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
607                echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
608                ln -sf "../"$builddir"/"$EXECUTABLE .
609            fi
610            if test ! -x $EXECUTABLE ; then
611                    rm -f $RUNLOG ; touch $RUNLOG
612                    if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
613                    echo " no executable:" $EXECUTABLE >> $RUNLOG
614                    RETVAL=8
615                    ENDVAL=-1
616            else
617                if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
618                  # output do not exist or is older than executable:
619                    rm -f $RUNLOG ; touch $RUNLOG
620                    if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
621                    ( eval $COMMAND ) >> $RUNLOG 2>&1
622                    RETVAL=$?
623              else              else
624                  return 1                  RETVAL=0
625                    if test -f $RUNLOG ; then
626                        if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
627                        echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
628                    else
629                        touch $RUNLOG
630                        if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
631                        echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
632                        echo " no previous $RUNLOG: assume NORMAL END" >> $RUNLOG 2>&1
633                    fi
634              fi              fi
635                ENDVAL=`cat $RUNLOG | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
636            fi
637            rm -f run.log_tmp
638            if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
639                tail $RUNLOG
640                echo successful 1>&2
641                # === Reduce the size of the testing emails!
642                #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
643                if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
644                return 0
645            elif [ $RETVAL -ne 0 -a $ENDVAL -gt 0 ] ; then
646                #-- for some weird cases (run is finihed but with error code)
647                tail $RUNLOG
648                echo finished with error '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
649                return 0
650            else
651                tail $RUNLOG
652                echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
653                cp $RUNLOG $CDIR"/"$RUNLOG
654                if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
655                return 1
656          fi          fi
657      )      )
658  }  }
# Line 283  createcodelet() Line 661  createcodelet()
661  {  {
662      # create codelet for comparing model output      # create codelet for comparing model output
663    
664      echo -n "creating the comparison code...  "      printf "creating the comparison code (using CC=$CC)...  "
665      cat > tmp_cmpnum.f <<EOFA      cat > tr_cmpnum.c <<EOF
666        program cmpnum  #include <stdio.h>
667        implicit none  #include <math.h>
668        real*8 a,b,diff  int main( int argc, char** argv )  {
669        integer linnum,best    int linnum,cmplin,best,lncnt;
670        best=-16    double a,b,abave,relerr;
671    99  read(*,*,end=70,err=60) linnum,a,b    best = -22;
672        diff=0.5*(abs(a)+abs(b))    lncnt = 0;
673  c     print *,a,b,diff,abs(a-b)/diff    while( 1 & ( (lncnt+=1) < 999 ) )  {
674        if (diff.gt.1.e-12) then      scanf("%d", &linnum);
675          diff=abs(a-b)/diff      if (linnum == -1)  break;
676          if (diff.gt.0.) then      scanf("%lf", &a);  scanf("%lf", &b);
677  c         print *,int(log10(diff)),diff      abave = 0.5*(fabs(a)+fabs(b));
678            linnum=int(log10(diff))      if ( abave == abave ) {
679            best=max(best,linnum)        if (abave > 0.0) {
680          endif          relerr=fabs(a-b)/abave;
681        else          if (relerr > 0.0) { cmplin = (int)rint(log10(relerr)); }
682          if (best.eq.-16.and.diff.ne.0.) best=-22          else { cmplin = -16 ; }
683        endif          best = (best > cmplin) ? best : cmplin; }
684        goto 99        else { cmplin = -22 ; }
685    60  stop 'cmpnum: An error occured reading a,b'     /* printf("%d ; %lf ; %lf\n",cmplin,a,b); */
686    70  print *,-best        }
687        end     else {
688  EOFA     /* printf("%lf ; %lf ; %lf\n",abave,a,b); */
689          break; }
690      }
691      if (lncnt == 999) best=-29;
692      if (linnum != -1) best=-99;
693      printf("%d\n", -best);
694      return 0;
695    }
696    EOF
697        $CC -o tr_cmpnum tr_cmpnum.c -lm
698    
699      f77 tmp_cmpnum.f      if [ -x ./tr_cmpnum ]; then
     if [ -x ./a.out ]; then  
700          echo "OK"          echo "OK"
701          return 0          return 0
702      else      else
703          echo          echo
704          echo "createcodelet: failed to compile codelet" | tee          echo "ERROR: failed to compile comparison code -- please specify"
705            echo "  a C compiler using the CC environment variable."
706          exit 1          exit 1
707      fi      fi
708  }  }
# Line 327  formatresults() Line 714  formatresults()
714      nm=$1      nm=$1
715      printf '%s %s %s %s' $2 $3 $4 $5      printf '%s %s %s %s' $2 $3 $4 $5
716      shift; shift; shift; shift; shift;      shift; shift; shift; shift; shift;
717      printf '%3s' $@      listPrt=$@
718        listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`
719        xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`
720        printf '%3s' $listPrt
721    #   line below does not work on hp-ux_ia64 : do those substitutions later on
722    #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
723            
724      if [ $1 = '--' ]; then      if [ $xx = '..' ]; then
725            printf ' N/O '
726        elif [ $xx = '--' ]; then
727            printf ' N/O '
728        elif [ $xx = 99 ]; then
729          printf ' N/O '          printf ' N/O '
730      else      else
731          if [ $1 -gt 12 ]; then          if [ $xx -ge $MATCH_CRIT ]; then
732              printf ' pass'              printf ' pass'
733          else          else
734              printf ' FAIL'              printf ' FAIL'
# Line 343  formatresults() Line 739  formatresults()
739            
740  }  }
741    
742  show_help()  scandirs()
743  {  {
744      cat - << EOF      if [ $# -eq 1 ]; then
745  $0 [-help] [-quick] [-verbose] dir1 [dir2] [...]          for arg in * ; do
746   -help      Show this help message              test -f $arg/$1 && echo $arg
747   -quick     Skip "genmake" and "make depend" if the Makefile exists          done
748   -quiet     Reduce the amount of output      else
749   -verbose   Produce copious amounts of output          echo $*
750   -debug     Produce even more output which will mean nothing to most      fi
  -force     Do "make CLEAN" before compiling. This forces a complete rebuild.  
  -clean     Do "make CLEAN" after compiling and testing.  
  -noieee    By default, $0 uses the -ieee option for genmake. This turns it off.  
  -cleanup   Aggresively removes all model output, executables and object files  
             and then exits. Use with care.  
   
 Normal usage:  
  $0 *       Configure, compile, run and analyze in all experiment directories  
 EOF  
751  }  }
752    
753  scandirs()  
754    check_eedata()
755  {  {
756      if [ $# -eq 0 ]; then      # check_eedata size.h eedata
757          for arg in * ; do      if [ $# -eq 2 ] ; then
758              test -d $arg/input && echo $arg        if test -f $1 -a -f $2 ; then
759          done        sx=`grep "^     & *nSx *=" $1 | sed "s/^     & *nSx *=//" | sed 's/, *$//'`
760          nx=`grep "^ *nTx *=" $2 | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
761          if test "x$nx" = x ; then
762            rx=10
763          else
764            rx=`expr $sx % $nx`
765          fi
766          sy=`grep "^     & *nSy *=" $1 | sed "s/^     & *nSy *=//" | sed 's/, *$//'`
767          ny=`grep "^ *nTy *=" $2 | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
768          if test "x$ny" = x ; then
769            ry=20
770          else
771            ry=`expr $sy % $ny`
772          fi
773          echo `expr $rx + $ry`
774      else      else
775          echo $*        echo '-1'
776          fi
777        else
778          echo '-2'
779      fi      fi
 }  
780    
781    }
782    
783  ###############################################################################  ###############################################################################
 ###############################################################################  
 ###############################################################################  
784    
785    
786  #  Default properties  #  Default properties
787  debug=0  debug=0
788  verbose=1  verbose=1
 quick=0  
789  clean=0  clean=0
 ieee=1  
 expts=''  
790    
791  OPTFILES=  IEEE=true
792  ADDRESSES=edhill@mitgcm.org  if test "x$MITGCM_IEEE" != x ; then
793        IEEE=$MITGCM_IEEE
794    fi
795    GSL=f
796    
797    CLEANUP=f
798    NORUN=f
799    QUICK=f
800    NOGENMAKE=f
801    NOCLEAN=f
802    NODEPEND=f
803    POSTCLEAN=f
804    
805    BASH=
806    OPTFILE=NONE
807    ADDRESSES=
808  TESTDIRS=  TESTDIRS=
809    SKIPDIRS=
810  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
811  MPACK="$MPACKDIR/mpack"  HAVE_MPACK=
812    MPACK=
813    COMMAND=
814    if test "x$MAKE" = x ; then
815        MAKE=make
816    fi
817    if test "x$CC" = x ; then
818        CC=cc
819    fi
820    JOBS=
821    MPI=f
822    MULTI_THREAD=f
823    OUTDIR=
824    DELDIR=
825    
826    ADM=
827    OADM=
828    
829  echo -n "parsing options...  "  # list of pTracers to check for monitor output
830    PTRACERS_NUM="1 2 3 4 5"
831    
832    MATCH_CRIT=13
833    
834    printf "parsing options...  "
835    
836  ac_prev=  ac_prev=
837  for ac_option ; do  for ac_option ; do
# Line 414  for ac_option ; do Line 851  for ac_option ; do
851              usage ;;              usage ;;
852                    
853          -optfile | --optfile | -of | --of)          -optfile | --optfile | -of | --of)
854              ac_prev=OPTFILES ;;              ac_prev=OPTFILE ;;
855          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
856              OPTFILES=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
857                    
858          -addr | --addr | -a | --a)          -addr | --addr | -a | --a)
859              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
860          -addr=* | --addr=*)          -addr=* | --addr=*)
861              ADDRESSES=$ac_optarg ;;              ADDRESSES=$ac_optarg ;;
862            -mpackdir | --mpackdir | -mpd | --mpd)
863                ac_prev=MPACKDIR ;;
864            -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*)
865                MPACKDIR=$ac_optarg ;;
866    
867          -tdir | --tdir | -t | --t)          -tdir | --tdir | -t | --t)
868              ac_prev=TESTDIRS ;;              ac_prev=TESTDIRS ;;
869          -tdir=* | --tdir=*)          -tdir=* | --tdir=*)
870              TESTDIRS=$ac_optarg ;;              TESTDIRS=$ac_optarg ;;
871    
872          -quick) quick=1 ;;          -skipdir | --skipdir | -skd | --skd)
873                ac_prev=SKIPDIRS ;;
874            -skipdir=* | --skipdir=*)
875                SKIPDIRS=$ac_optarg ;;
876    
877            -bash | --bash | -b | --b)
878                ac_prev=BASH ;;
879            -bash=* | --bash=*)
880                BASH=$ac_optarg ;;
881    
882            -command | --command | -c | --c)
883                ac_prev=COMMAND ;;
884            -command=* | --command=*)
885                COMMAND=$ac_optarg ;;
886    
887            -make | --make | -m | --m)
888                ac_prev=MAKE ;;
889            -make=* | --make=*)
890                MAKE=$ac_optarg ;;
891    
892            -odir | --odir)
893                ac_prev=OUTDIR ;;
894            -odir=* | --odir=*)
895                OUTDIR=$ac_optarg ;;
896    
897            -ptracers | --ptracers | -ptr | --ptr)
898                ac_prev=PTRACERS_NUM ;;
899            -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)
900                PTRACERS_NUM=$ac_optarg ;;
901    
902            -match | --match ) ac_prev=MATCH_CRIT ;;
903            -match=* | --match=* ) MATCH_CRIT=$ac_optarg ;;
904    
905            -j) ac_prev=JOBS ;;
906            -j=*) JOBS=$ac_optarg ;;
907    
908            -clean | --clean)
909                CLEANUP=t ; DELDIR=t ;;
910    
911            -norun | --norun | -nr | --nr)
912                NORUN=t ;;
913            -quick | --quick | -q | --q)
914                QUICK=t ;;
915            -nogenmake | --nogenmake | -ng | --ng)
916                NOGENMAKE=t ;;
917            -noclean | --noclean | -nc | --nc)
918                NOCLEAN=t ;;
919            -nodepend | --nodepend | -nd | --nd)
920                NODEPEND=t ;;
921    
922            -postclean | --postclean | -pc | --pc)
923                POSTCLEAN=t ;;
924    
925            -mpi) MPI=t ;;
926    
927            -mth) MULTI_THREAD=t ;;
928    
929            -adm | -ad) ADM=t ;;
930    
931            -oad) OADM=t; NODEPEND=t ;;
932    
933            -ieee) IEEE=true ;;
934            -noieee) IEEE= ;;
935            -gsl) GSL=t ;;
936    
937          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
938          -debug) debug=1 ;;          -debug) debug=1 ;;
         -clean) clean=1 ;;  
         -noieee) ieee=0 ;;  
939          -quiet) verbose=0 ;;          -quiet) verbose=0 ;;
940    
941            -deldir | -dd) DELDIR=t ;;
942    
943            -ts) TS=t;;
944    
945            -papis) PAPIS=t;;
946    
947            -pcls) PCL=t;;
948    
949          -*)          -*)
950              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
951              usage              usage
# Line 449  for ac_option ; do Line 960  for ac_option ; do
960            
961  done  done
962    
963    if test "x$QUICK" = xt ; then
964        NOGENMAKE=t
965        NOCLEAN=t
966        NODEPEND=t
967    fi
968    
969    #- setting for forward or ADM testing
970    if test "x$ADM" = xt ; then
971        code_dir=code_ad
972        inputdir=input_ad
973        ref_outp="output_adm.txt"
974        EXECUTABLE="mitgcmuv_ad"
975    elif test "x$OADM" = xt ; then
976        code_dir=code_oad
977        inputdir=input_oad
978        ref_outp="output_oadm.txt"
979        EXECUTABLE="mitgcmuv_ad"
980    else
981        code_dir=code
982        inputdir=input
983        ref_outp="output.txt"
984        EXECUTABLE="mitgcmuv"
985    fi
986    
987  if test "x$TESTDIRS" = x ; then  if test "x$TESTDIRS" = x ; then
988      TESTDIRS=`scandirs`      LIST=`scandirs results/$ref_outp`
989    else
990        #- expand group of experiments:
991        LIST=" "
992        for xx in $TESTDIRS
993        do
994          case $xx in
995            'basic') LIST=${LIST}" aim.5l_cs hs94.128x64x5 ideal_2D_oce"
996                     LIST=${LIST}" lab_sea tutorial_baroclinic_gyre"
997                     LIST=${LIST}" tutorial_global_oce_latlon tutorial_plume_on_slope"
998                    ;;
999            'tutorials')
1000                     LIST=${LIST}" "`ls | grep 'tutorial_'` ;;
1001            *)       LIST=${LIST}" "$xx ;;
1002          esac
1003        done
1004    fi
1005    #echo 'LIST='${LIST}'<'
1006    #- skip dirs, remove duplicate and non-directory:
1007    TESTDIRS=" "
1008    count=0
1009    for xx in $LIST
1010    do
1011        yy=`echo $SKIPDIRS | grep -c $xx`
1012        if test $yy = 0 ; then
1013            if test -d $xx ; then
1014                yy=`echo $TESTDIRS | grep -c $xx`
1015                if test $yy = 0 ; then TESTDIRS=${TESTDIRS}" "$xx ; fi
1016            else count=1 ;
1017                echo ""; echo -n " -- skip \"$xx\" (not a directory !)"
1018            fi
1019        else
1020            if test $count = 1 ; then echo -n ", \"$xx\""
1021            else count=1 ; echo "" ;  echo -n " skip: \"$xx\""
1022            fi
1023        fi
1024    done
1025    if test $count = 1 ; then echo "" ; echo -n " ... " ; fi
1026    #echo 'TESTDIRS='${TESTDIRS}'<'
1027    
1028    if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then
1029        OPTFILE=$MITGCM_OF
1030    fi
1031    
1032    RUNLOG="run.log"
1033    OUTPUTFILE=$ref_outp
1034    if test "x$COMMAND" = x ; then
1035        COMMAND="./$EXECUTABLE > $OUTPUTFILE"
1036    fi
1037    if test "x$MPI" = xt ; then
1038        OUTPUTFILE="STDOUT.0000"
1039  fi  fi
1040    
1041  echo "OK"  echo "OK (COMMAND= $COMMAND )"
1042    
1043    # set the Default List of output variables to be checked:
1044    #  (use default or load experiment-specific list from file "tr_checklist")
1045    # content : 1rst = main variable used to decide if it pass or FAIL
1046    #         others = number of matching digits to be printed in summary.txt
1047    if test "x$ADM" = x -a "x$OADM" = x; then
1048        DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
1049        EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
1050        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1051        ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
1052        EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
1053    else
1054        DEF_CHECK_LIST='Grad Cost Grad'
1055        EMPTY_RESULTS='.. ..'
1056        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1057    fi
1058    
1059  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1060  createcodelet  if test -x tr_cmpnum ; then
1061        echo "skipping comparison code build"
1062    else
1063        createcodelet
1064    fi
1065    
1066  #  build the mpack utility  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
1067  build_mpack  if test "x$ADDRESSES" = x ; then
1068        echo "skipping mpack build"
1069    else
1070        build_mpack
1071    fi
1072    
1073  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
1074    CMDLINE=$0
1075    for xx in "$@" ; do nw=`echo $xx | wc -w`
1076        if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"
1077                            else CMDLINE="$CMDLINE '$xx'" ; fi
1078    done
1079    #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
1080  MACH=`hostname`  MACH=`hostname`
1081  UNAMEA=`uname -a`  UNAMEA=`uname -a`
1082  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
1083  BASE=$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
1084    if test "x$OUTDIR" != x ; then
1085        BASE="tr_"$OUTDIR"_"$DATE"_"
1086    else
1087        short_name=`hostname | sed 's/\..*$//'`
1088        BASE="tr_"$short_name"_"$DATE"_"
1089    fi
1090  DNUM=0  DNUM=0
1091  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
1092  while test -e $DRESULTS ; do  while test -e $DRESULTS ; do
# Line 475  done Line 1096  done
1096  mkdir $DRESULTS  mkdir $DRESULTS
1097  RETVAL=$?  RETVAL=$?
1098  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
1099      echo "Error: can't create results directory \"./$DRESULTS\""      echo "ERROR: Can't create results directory \"./$DRESULTS\""
1100      exit 1      exit 1
1101  fi  fi
1102  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
1103  date > $SUMMARY  start_date=`date`
1104  cat << EOF >> $SUMMARY  echo $start_date > $SUMMARY
1105                  T           S           U           V  echo 'run:' $CMDLINE >> $SUMMARY
1106  G D M    c        m  s        m  s        m  s        m  s  echo 'on :' $UNAMEA  >> $SUMMARY
1107  E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .  
1108  N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d  of_path=
1109  2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .  if test "x$OPTFILE" != xNONE ; then
1110        if test -r $OPTFILE ; then
1111            # get the path
1112            path=${OPTFILE%/*}
1113            if test "x$path" = x ; then
1114                of_path=`pwd`
1115            else
1116                of_path=`( cd $path > /dev/null 2>&1 ; pwd )`
1117            fi
1118            file=${OPTFILE##*/}
1119            OPTFILE=$of_path/$file
1120            cp $OPTFILE $DRESULTS
1121            echo >> $SUMMARY
1122            echo "  OPTFILE=$OPTFILE" >> $SUMMARY
1123        else
1124            echo | tee $SUMMARY
1125            echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee $SUMMARY
1126            exit 1
1127        fi
1128    else
1129        echo >> $SUMMARY
1130        echo "No \"OPTFILE\" was explicitly specified by testreport," >> $SUMMARY
1131        echo "   so the genmake default will be used." >> $SUMMARY
1132    fi
1133    echo
1134    echo >> $SUMMARY
1135    if test "x$ADM" = x -a "x$OADM" = x; then
1136        if [ $MATCH_CRIT -lt 10 ] ;
1137        then line_0="default  "$MATCH_CRIT ;
1138        else line_0="default "$MATCH_CRIT ; fi
1139           line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1140    #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"
1141        line_1="G D M    c        m  s        m  s        m  s        m  s"
1142        line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
1143        line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1144        line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1145        for ii in $PTRACERS_NUM ; do
1146            line_0="$line_0  --PTR 0"$ii"--"
1147            line_1="$line_1        m  s"
1148            line_2="$line_2  m  m  e  ."
1149            line_3="$line_3  i  a  a  d"
1150            line_4="$line_4  n  x  n  ."
1151        done
1152        echo "$line_0" | tee -a $SUMMARY
1153        echo "$line_1" | tee -a $SUMMARY
1154        echo "$line_2" | tee -a $SUMMARY
1155        echo "$line_3" | tee -a $SUMMARY
1156        echo "$line_4" | tee -a $SUMMARY
1157        echo " "       | tee -a $SUMMARY
1158    else
1159        echo "ADJOINT=true" >> $SUMMARY
1160        echo >> $SUMMARY
1161        if [ $MATCH_CRIT -lt 10 ] ;
1162        then line_0="default     "$MATCH_CRIT ;
1163        else line_0="default    "$MATCH_CRIT ; fi
1164        echo "$line_0" | tee -a $SUMMARY
1165        cat << EOF | tee -a $SUMMARY
1166    G D M    C  G
1167    E p a R  o  r
1168    N n k u  s  a
1169    2 d e n  t  d
1170    
1171  EOF  EOF
1172    fi
1173    
1174  NDIR=0  #  ...and each test directory...
1175    for dir in $TESTDIRS ; do
1176        
1177        # set builddir & rundir:
1178        builddir="build"
1179        if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1180        rundir="run"
1181        if test ! -d $dir/$rundir ; then
1182            rundir=$builddir
1183        fi
1184        CODE_DIR=$dir/$code_dir
1185        BUILD_DIR=$dir/$builddir
1186    
1187  #  For each optfile...      #  Cleanup only!
1188  for OPTFILE in $OPTFILES ; do      if test "x$CLEANUP" = xt ; then
1189            echo -n '  --- dir:' $BUILD_DIR ': '
1190            makeclean $BUILD_DIR
1191            rm -f $BUILD_DIR/$EXECUTABLE
1192            if test -d $dir/$rundir/CVS ; then
1193                echo -n '  --- dir:' $dir/$rundir ': '
1194                run_clean $dir/$rundir
1195            fi
1196            trdir=`( cd $dir ; find . -type d -name "tr_run.*" -print | sed 's/^.\///')`
1197            ttd=`echo $trdir | wc -w`
1198            if test $ttd != 0 ; then
1199                echo '  --- rm dir:' $trdir
1200                ( cd $dir ; rm -rf $trdir )
1201            fi
1202            continue
1203        fi
1204    
1205      OPTFILE=`pwd`"/$OPTFILE"      #  Verify that the testdir exists and contains previous
1206      if test ! -r $OPTFILE ; then      #  results in the correct location--or skip this directory!
1207          echo "Error: can't read optfile \"$OPTFILE\""      fout=$dir"/results/"$ref_outp
1208          exit 1      if test ! -r $fout ; then
1209            echo "can't read \"$fout\" -- skipping $dir"
1210            continue
1211      fi      fi
     echo  
     echo "OPTFILE=$OPTFILE" >> $SUMMARY  
     echo >> $SUMMARY  
       
     #  ...and each test directory...  
     for dir in $TESTDIRS ; do  
           
         #  Create an output dir for each OPTFILE/tdir combination  
         CDIR=$DRESULTS"/"$DRESULTS"_"$NDIR  
         mkdir $CDIR  
         CDIR=`pwd`"/$CDIR"  
1212    
1213          #  ...configue, make, run, and compare the output.      # Check for specific files for particular type of run
1214          echo "-------------------------------------------------------------------------------"  
1215          echo      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1216          echo "Experiment:  $dir"          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
1217          echo          continue
1218          unset genmake makedepend make run      fi
1219          results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'      if test ! -r $dir"/input/eedata.mth" -a "x$MULTI_THREAD" = "xt" ; then
1220          ( cd $dir/input; rm -f *.{o,f,c,F} *.[f,F]90 work* output.txt Make* make.log; )          echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"
1221          if [ -r $dir/build ]; then          continue
1222              seperatebuilddir=1      fi
1223              builddir=build      if test "x$MPI" = "xt" -a "x$MULTI_THREAD" = "xt" ; then
1224              rundir=build        retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/input/eedata.mth"`
1225              ( cd $dir/build; ln -sf ../input/* . )        if test $retv != 0 ; then
1226          else          echo "input/eedata.mth tiling misfit -- skipping $dir"
1227              seperatebuilddir=0          continue
1228              builddir=input        fi
1229              rundir=input      fi
         fi  
1230    
1231          #  Verify that the testdir exists and contains previous      #  Check whether there are "extra runs" for this testdir
1232          #  results in the correct location--or skip this directory!      extra_runs=
1233          if test ! -r $dir"/results/output.txt" ; then      if test "x$NORUN" = xf ; then
1234              echo | tee $SUMMARY          ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1235              echo "can't read \"$dir/results/output.txt\" -- skipping $dir" \      fi
1236                  | tee $SUMMARY      #echo "ex_run_dirs='$ex_run_dirs'"
1237              continue      for exd in $ex_run_dirs ; do
1238            name=`echo $exd | sed -e "s/$inputdir\.//"`
1239            refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1240            outf="$dir/results/$refExOut"
1241            if test -f $outf -a -r $outf ; then
1242              if test "x$MULTI_THREAD" = "xt" ; then
1243                if test -r $dir"/"$exd"/eedata.mth" ; then
1244                  if test "x$MPI" = "xt" ; then
1245                    retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/"$exd"/eedata.mth"`
1246                    if test $retv = 0 ; then
1247                        extra_runs="$extra_runs $name"
1248                    else
1249                        echo $exd"/eedata.mth tiling misfit -- skipping $dir"
1250                    fi
1251                  else
1252                    extra_runs="$extra_runs $name"
1253                  fi
1254                #else echo $dir"/"$exd"/eedata.mth: not found"
1255                fi
1256              else
1257                extra_runs="$extra_runs $name"
1258              fi
1259          fi          fi
1260        done
1261    
1262        echo "-------------------------------------------------------------------------------"
1263        echo
1264        if test "x$extra_runs" = "x" ; then
1265           echo "Experiment:  $dir"
1266        else
1267           echo "Experiment:  $dir ; extra_runs=$extra_runs"
1268        fi
1269        echo
1270        unset genmake makedepend make run
1271        results=$EMPTY_RESULTS
1272    
1273        #  Create an output dir for each OPTFILE/tdir combination
1274        rel_CDIR=$DRESULTS"/"$dir
1275        mkdir $rel_CDIR
1276        CDIR=`pwd`"/$rel_CDIR"
1277        
1278        if test "x$NORUN" = xt ; then
1279                run=N
1280          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1281              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
1282                && run_clean $dir/$rundir \
1283                && symlink_mpifiles $dir $code_dir $builddir \
1284                && makedependmodel $dir/$builddir && makedepend=Y \
1285                && makemodel $dir/$builddir && make=Y
1286        else
1287            genmakemodel $dir/$builddir && genmake=Y \
1288                && makeclean $dir/$builddir \
1289                && run_clean $dir/$rundir \
1290                && symlink_mpifiles $dir $code_dir $builddir \
1291              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1292              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1293              && linkdata $seperatebuilddir $dir/$rundir \              && linkdata $dir/$rundir $inputdir input \
1294              && runmodel $dir/$builddir mitgcmuv && run=Y \              && runmodel $dir/$rundir && run=Y \
1295              && results=`testoutput $dir $rundir`              && results=`testoutput_run $dir $rundir $ref_outp`
1296          echo      fi
1297          formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \      
1298              ${run:-N} $results      #echo "results='$results'"
1299        echo
1300            fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1301          echo          echo
1302          formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1303              ${run:-N} $results >> $SUMMARY          touch $CDIR"/summary.txt"
1304          echo "fresults='" > $CDIR"/summary.txt"          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
         formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} \  
             ${run:-N} $results >> $CDIR"/summary.txt"  
         echo "'" >> $CDIR"/summary.txt"  
1305          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1306          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1307          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1308          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1309            if test "x$ADM" = xt ; then
1310                head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1311                grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1312                                    >> $CDIR"/summary.txt"
1313            fi
1314    
1315          (          for ex in $extra_runs ; do
1316              cd $DRESULTS              unset run
1317              tar -cf $NDIR".tar" $DRESULTS"_"$NDIR > /dev/null 2>&1              results=$EMPTY_RESULTS
1318              gzip $NDIR".tar"              #  reference output file
1319          )              refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1320                #  Create an output dir for each OPTFILE/tdir.ex combination
1321                rel_CDIR=$DRESULTS"/"$dir"."$ex
1322                mkdir $rel_CDIR
1323                CDIR=`pwd`"/$rel_CDIR"
1324                test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1325                run_clean $dir/tr_run.$ex
1326                linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input
1327                runmodel $dir/tr_run.$ex && run=Y \
1328                && results=`testoutput_run $dir tr_run.$ex $refExOut`
1329                fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1330                fres="$fres.$ex"
1331                echo
1332                echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1333                touch $CDIR"/summary.txt"
1334                echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1335                echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1336                echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1337                echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1338                echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1339                if test "x$ADM" = xt ; then
1340                    head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1341                    grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \
1342                                       >> $CDIR"/summary.txt"
1343                fi
1344                if test "x$POSTCLEAN" = xt ; then
1345                    run_clean $dir/tr_run.$ex
1346                fi
1347            done
1348    
1349        #postclean $dir/$builddir
1350        if test "x$POSTCLEAN" = xt ; then
1351            makeclean $dir/$builddir \
1352                && run_clean $dir/$rundir
1353        fi
1354        
1355        echo "-------------------------------------------------------------------------------"
1356        
1357    done
1358    
1359          $MPACK -s MITgcm-test -m 1000000 $DRESULTS"/"$NDIR".tar.gz" $ADDRESSES  printf "Start time:  " >> $SUMMARY
1360    echo "$start_date" >> $SUMMARY
1361    printf "End time:    " >> $SUMMARY
1362    date >> $SUMMARY
1363    
1364    #  If addresses were supplied and mpack built successfully, then try
1365    #  to send email using mpack.
1366    if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
1367        echo "No results email was sent."
1368    else
1369        if test "x$HAVE_MPACK" = xt ; then
1370            tar -cf $DRESULTS".tar" $DRESULTS > /dev/null 2>&1 \
1371                && gzip $DRESULTS".tar" \
1372                && $MPACK -s MITgcm-test -m 3555000 $DRESULTS".tar.gz" $ADDRESSES
1373          RETVAL=$?          RETVAL=$?
1374          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1375              echo "Warning: \"$MPACK\" failed -- please contact <edhill@mitgcm.org>"              echo
1376                echo "Warning: The tar, gzip, & mpack step failed.  Please send email"
1377                echo "  to <MITgcm-support@mitgcm.org> for help.  You may copy the "
1378                echo "  summary of results from the directory \"$DRESULTS\"."
1379                echo
1380          else          else
1381              rm -f $DRESULTS"/"$NDIR".tar*"              echo
1382                echo "An email containing results was sent to the following addresses:"
1383                echo "  \"$ADDRESSES\""
1384                echo
1385                test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"
1386                test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"
1387          fi          fi
1388        fi
1389    fi
1390    
1391          NDIR=$(( $NDIR + 1 ))  if test "x$QUICK" = xf -a "x$NORUN" = xf ; then
1392                rm -f tr_cmpnum.c tr_cmpnum
1393      done  fi
 done  
1394    
1395  rm tmp_cmpnum.f a.out  if test "x$CLEANUP" != xt ; then
1396        cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
1397        if test -e tr_out.txt ; then
1398            mv tr_out.txt tr_out.txt.old
1399        fi
1400        cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1401    fi
1402    
1403  cat $SUMMARY  if test "x$DELDIR" = xt ; then
1404        rm -rf $DRESULTS
1405    fi
1406    

Legend:
Removed from v.1.2  
changed lines
  Added in v.1.134

  ViewVC Help
Powered by ViewVC 1.1.22